/**
 * This class represents the bounding walls of the game. The space has a certain
 * width w and height h. The upper left corner is the point (0, 0), and the
 * lower right corner is the point (w, h).
 */
public class Walls {
    
    private double width, height;  //Dimensions of bounding walls of the game
    
    /**
     * Constructs the bounding space.
     * @param width the width of the space
     * @param height the height of the space
     */
    public Walls(double width, double height) {
        // TODO implement me!
    }
    
    /**
     * Returns the width of the space.
     * @return the width
     */
    public double getWidth() {
        // TODO replace the following line with your code
        return 800;
    }
    
    /**
     * Returns the height of the space.
     * @return the height
     */
    public double getHeight() {
        // TODO replace the following line with your code
        return 600;
    }
    
    /**
     * Checks if the given ball has hit a wall. If it has, this method should
     * update the position and velocity of the ball appropriately.
     * @param ball the ball to check
     */
    public void checkBounce(Ball ball) {
        if (ball.isExploding()) {
            // exploding balls don't bounce, so do nothing and return
            return;
        }
        
        // get current position, radius, and velocity
        double x = ball.getCenter().getX();
        double y = ball.getCenter().getY();
        double r = ball.getRadius();
        double vx = ball.getVelocity().getX();
        double vy = ball.getVelocity().getY();
        
        // check if ball has moved past the left wall
        if (x - r < 0) {
            // this "bounces" the ball back by amount it has gone past the wall
            x = r - (x - r);
            // the x component of velocity is now reversed
            vx = -vx;
        }
        
        // TODO check right, top, and bottom walls
        
        // set new position and velocity
        ball.getCenter().setX(x);
        ball.getCenter().setY(y);
        ball.getVelocity().setX(vx);
        ball.getVelocity().setY(vy);
    }

}
